//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                           bc-PSI@SAR_Complete.mqh |
//|                                    Copyright  2011-12, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|  06.09.2012     SAR  BrakeExp  . .                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  -  |
//|      (TarasBY).      |
//|       ,      .  |
//|      .                              |
//|         ,    - |
//| .                                                            |
//|     ,    ,    |
//|     Skype: TarasBY  e-mail.                           |
//+-----------------------------------------------------------------------------------+
//|   This product is intended for non-commercial use.  The publication is only allo- |
//|wed when you specify the name of the author (TarasBY). Edit the source code is va- |
//|lid only under condition of preservation of the text, links and author's name.     |
//|   Selling a module or(and) parts of it PROHIBITED.                                |
//|   The author is not liable for any damages resulting from the use of a module.    |
//|   For all matters relating to the work of the module, comments or suggestions for |
//|their improvement in the contact Skype: TarasBY or e-mail.                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                 *****                  *****                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string SETUP_RulesSend       = "---------------- RULES`s SEND -----------------";
extern int    VariantSend              = 0;                //     :
// 0 -  MA
// 1 - SAR;
// 2 - iCustom ("BrakeExp");;
// 3 - SAR + iCustom ("BrakeExp");;
extern int    SignalSendOnBar          = 1;                //    ( )    
extern int    VerificationSendBars     = 2;                //      
#include      <bs-PSI@SAR.mqh>                             //     SAR  BrakeExp
#include      <bs-PSI@MA.mqh>                              //     MA
#include      <bf-PSI@ATR.mqh>                             //    ATR
#include      <bf-PSI@INTRA.mqh>                           //   IntraDay
extern string SETUP_RulesClose      = "---------------- RULES`s CLOSE ----------------";
extern int    Use_close_IND            = 0;                //    :
// 1 -  SAR;
// 2 -  iCustom ("BrakeExp");
// 3 - SAR + iCustom ("BrakeExp");;
/*extern*/ int    SignalCloseOnBar         = 1;                //    ( )    
/*extern*/ int    VerificationCloseBars    = 3;                //      
extern int    NBars_LifeMIN            = 0;                //  ""   NBars_LifeMIN   TF_Indicators  ( Use_close_IND > 0)
extern int    NBars_LifeMAX            = -1;               //  ""   NBars_LifeMAX     (0 -      )
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII===========  =========IIIIIIIIIIIIIIIIIIIIII+
/*int fGet_SignalSend (string fs_Symbol,                   // Symbol
                       int fi_TF,                          // 
                       int fi_VariantSend,                 //   
                       int fi_BarSignal = 1,               //     
                       int fi_VerificationBars = 1)*/      //     
                            //      
/*int fSend_Control (int& fi_Trend)                        //   
                            //      
/*bool fGet_SignalClose (string fs_Symbol,                 // Symbol
                         int fi_TF,                        // 
                         int fi_VariantClose,              //   
                         int& fi_CloseSignal,              //    
                         int fi_BarSignal = 1,             //     
                         int fi_VerificationBars = 1)*/    //     
                            //      
//bool fCheck_ExternParametersSAR()
                            //      .
//bool fSet_ContinueSARComplete()
                            //    "" 
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_SignalSend (string fs_Symbol,            // Symbol
                     int fi_TF,                   // 
                     int fi_VariantSend,          //   
                     int fi_BarSignal = 1,        //     
                     int fi_VerificationBars = 1) //     
{
//----
    //----   
    switch (fi_VariantSend)
    {
        //---- Parabolic SAR
        case 1:
            bool lb_ControlBeginChangeTrend = fControl_BeginChangeTrend (Use_ChangeTrend.SAR, bi_curOrdersInSeries == 0);
            return (fGet_SignalSAR (fs_Symbol, fi_TF, lb_ControlBeginChangeTrend, fi_BarSignal, fi_VerificationBars));
        //---- iCustom ("BrakeExp");
        case 2:
            lb_ControlBeginChangeTrend = fControl_BeginChangeTrend (Use_ChangeTrend.BrakeExp, bi_curOrdersInSeries == 0);
            return (fGet_SignalBrakeExp (fs_Symbol, fi_TF, fi_BarSignal, fi_VerificationBars));
         //---- Parabolic SAR + iCustom ("BrakeExp");
        case 3:
            int lia_Signal[2];
            lb_ControlBeginChangeTrend = fControl_BeginChangeTrend (Use_ChangeTrend.SAR, bi_curOrdersInSeries == 0);
            lia_Signal[0] = fGet_SignalSAR (fs_Symbol, fi_TF, lb_ControlBeginChangeTrend, fi_BarSignal, fi_VerificationBars);
            if (lia_Signal[0] == STOP) return (STOP);
            lb_ControlBeginChangeTrend = fControl_BeginChangeTrend (Use_ChangeTrend.BrakeExp, bi_curOrdersInSeries == 0);
            lia_Signal[1] = fGet_SignalBrakeExp (fs_Symbol, fi_TF, lb_ControlBeginChangeTrend, fi_BarSignal, fi_VerificationBars);
            if (lia_Signal[1] == STOP) return (STOP);
            if (lia_Signal[0] == BULL) {if (lia_Signal[1] == BULL) return (BULL);}
            else if (lia_Signal[0] == BEAR) {if (lia_Signal[1] == BEAR) return (BEAR);}
            return (STOP);
        //----  MA;
        default: return (fGet_SignalMA (fs_Symbol, fi_TF, fi_BarSignal, fi_VerificationBars));
    }
//----
    return (STOP);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fSend_Control (int& fi_Trend)       //   
{
    int li_Filter.INTRA = 2;
//----
    //fi_Trend = SendOnlyOrders;
    //----   ATR
    if (Filter.ATR % 2 != 0)
    {
        if (!fGet_SignalATR (bs_Symbol, TF_Indicators, SignalSendOnBar, VerificationSendBars))
        {/*fWrite_Log ("    ATR.", 3); */return (STOP);}
    }
    //----   INTRA
    if (Filter.INTRA > 0)
    {li_Filter.INTRA = fGet_SignalINTRA (bs_Symbol, TF_F.INTRA, Percent_F.INTRA, Filter.INTRA);}
    if (li_Filter.INTRA < 0) return (STOP);
    //----    
    int li_Signal = fGet_SignalSend (bs_Symbol, TF_Indicators, VariantSend, SignalSendOnBar, VerificationSendBars);
    if (li_Signal == STOP) return (STOP);
    if (li_Filter.INTRA != 2) if (li_Signal != li_Filter.INTRA) return (STOP);
//----
    return (li_Signal);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fGet_SignalClose (string fs_Symbol,            // Symbol
                       int fi_TF,                   // 
                       int fi_VariantClose,         //   
                       int& fi_CloseSignal,         //    
                       int fi_BarSignal = 1,        //     
                       int fi_VerificationBars = 1) //     
{
    //----      
    if (fi_VariantClose <= 0) return (false);
    int li_Trend = STOP;
//----
    //----   ATR
    if (Filter.ATR > 1)
    {
        if (!fGet_SignalATR (fs_Symbol, fi_TF, fi_BarSignal, fi_VerificationBars))
        {return (false);}
    }
    //----    
    switch (fi_VariantClose)
    {
        //----   SAR
        case 1: li_Trend = fGet_SignalSAR (fs_Symbol, fi_TF, False, fi_BarSignal, fi_VerificationBars); break;
        //----   iCustom ("BrakeExp")
        case 2: li_Trend = fGet_SignalBrakeExp (fs_Symbol, fi_TF, False, fi_BarSignal, fi_VerificationBars); break;
        //----   SAR + iCustom ("BrakeExp")
        case 3:
            li_Trend = fGet_SignalSAR (fs_Symbol, fi_TF, False, fi_BarSignal, fi_VerificationBars);
            if (li_Trend >= 0)
            {if (li_Trend != fGet_SignalBrakeExp (fs_Symbol, fi_TF, False, fi_BarSignal, fi_VerificationBars)) return (false);}
            break;
    }
    //----     - 
    if (li_Trend == STOP) return (false);
    fi_CloseSignal = 1;
    if (li_Trend == 1) fi_CloseSignal = 0;
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//              .                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_ExternParametersSAR()
{
//----
    //----    
    if (VariantSend < 0 || VariantSend > 3) {bs_ERROR = " 3 <= VariantSend >= 0 !!!"; return (false);}
    if (SignalSendOnBar < 0) {bs_ERROR = " SignalSendOnBar >= 0 !!!"; return (false);}
    if (VerificationSendBars < 1) {bs_ERROR = " VerificationSendBars >= 1 !!!"; return (false);}
    if (SignalCloseOnBar < 0) {bs_ERROR = " SignalCloseOnBar >= 0 !!!"; return (false);}
    if (VerificationCloseBars < 1) {bs_ERROR = " VerificationCloseBars >= 1 !!!"; return (false);}
    if (Filter.ATR < 0 || Filter.ATR > 3) {bs_ERROR = " 3 <= Filter.ATR >= 0 !!!"; return (false);}
    if (Source_F.ATR < 0 || Source_F.ATR > 3) {bs_ERROR = " 3 <= Source_F.ATR >= 0 !!!"; return (false);}
    if (Filter.INTRA < 0 || Filter.INTRA > 2) {bs_ERROR = " 2 <= Filter.INTRA >= 0 !!!"; return (false);}
    if (NBars_LifeMAX > 0) if (NBars_LifeMIN > NBars_LifeMAX) {bs_ERROR = " NBars_LifeMIN <= Filter.NBars_LifeMAX  0 >= NBars_LifeMAX >= -1 !!!"; return (false);}
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_ContinueSARComplete()
{
//----
    if (Use_close_IND == 0) if (Filter.ATR >= 2) {bb_OptimContinue = true; return (true);}
    if (Filter.INTRA == 0) if (Percent_F.INTRA != 0.5) {bb_OptimContinue = true; return (true);}
    if (VariantSend == 1) {if (Use_ChangeTrend.BrakeExp != 0) return (true);}
    if (VariantSend == 2) {if (Use_ChangeTrend.SAR != 0) return (true);}
    if (VariantSend == 0)
    {
        if (Use_ChangeTrend.BrakeExp != 0) return (true);
        if (Use_ChangeTrend.SAR != 0) return (true);
    }
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

