//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                    bs-PSI@SAR.mqh |
//|                                    Copyright  2011-12, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|  06.08.2012      SAR  BrakeExp.                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  -  |
//|      (TarasBY).      |
//|       ,      .  |
//|      .                              |
//|         ,    - |
//| .                                                            |
//|     ,    ,    |
//|     Skype: TarasBY  e-mail.                           |
//+-----------------------------------------------------------------------------------+
//|   This product is intended for non-commercial use.  The publication is only allo- |
//|wed when you specify the name of the author (TarasBY). Edit the source code is va- |
//|lid only under condition of preservation of the text, links and author's name.     |
//|   Selling a module or(and) parts of it PROHIBITED.                                |
//|   The author is not liable for any damages resulting from the use of a module.    |
//|   For all matters relating to the work of the module, comments or suggestions for |
//|their improvement in the contact Skype: TarasBY or e-mail.                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define NAME_Ind "BrakeExp"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                 *****                  *****                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string Setup_SAR             = "*************** Send/Close SAR ****************";
/*extern*/ int    USE_SAR                  = 1;               // 0 - off; 1 - send; 2 - close; 3 - send + close
extern int    Use_ChangeTrend.SAR      = 0;               // 0 - off;     : 1 -   ; 2 -    ; 3 -  
extern double SAR_Step                 = 0.0035;
extern double SAR_Maximum              = 0.5;
extern string Setup_BrakeExp        = "************* Send/Close BrakeExp *************";
/*extern*/ int    USE_BrakeExp             = 1;               // 0 - off; 1 - send; 2 - close; 3 - send + close
extern int    Use_ChangeTrend.BrakeExp = 0;               // 0 - off;     : 1 -   ; 2 -    ; 3 -  
extern double ValueA                   = 2.4;
extern double ValueB                   = 0.05;
/*extern*/ bool   IsLine                   = TRUE;             //    
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII===========  =========IIIIIIIIIIIIIIIIIIIIII+
/*int fGet_SignalSAR (string fs_Symbol,                   // Symbol
                      int fi_TF,                          // 
                      bool fb_ControlBeginChangeTrend = False,//    
                      int fi_BarSignal = 1,               //     
                      int fi_VerificationBars = 1)*/      //     
                            //   SAR  fi_BarSignal 
/*int fGet_SignalBrakeExp (string fs_Symbol,              // Symbol
                           int fi_TF,                     // 
                           bool fb_ControlBeginChangeTrend = False,//    
                           int fi_BarSignal = 1,          //     
                           int fi_VerificationBars = 1)*/ //     
                            //   BrakeExp  fi_BarSignal 
/*bool fControl_BeginChangeTrend (int fi_ControlBeginChangeTrend = 0,//  
                                  bool fb_FirstOrder = true)*///    ( )
                            //       
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          SAR  fi_BarSignal                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_SignalSAR (string fs_Symbol,                        // Symbol
                    int fi_TF,                               // 
                    bool fb_ControlBeginChangeTrend = False, //    
                    int fi_BarSignal = 1,                    //     
                    int fi_VerificationBars = 1)             //     
{
    double ld_Sar, ld_MA;
    bool   lb_Trend = false;
//----
    if (!fb_ControlBeginChangeTrend) fi_VerificationBars--;
    //----      (fi_BarSignal)    (fi_VerificationBars) 
    for (int li_BAR = fi_BarSignal + fi_VerificationBars; li_BAR >= fi_BarSignal; li_BAR--)
    {
        //----  SAR
        ld_Sar = iSAR (fs_Symbol, fi_TF, SAR_Step, SAR_Maximum, li_BAR);
        //----  
        ld_MA = iMA (fs_Symbol, fi_TF, 3, 0, MODE_SMMA, PRICE_TYPICAL, li_BAR);
        //----    
        if (fb_ControlBeginChangeTrend)
        {if (!lb_Trend) {if (ld_MA <= ld_Sar) {lb_Trend = true; continue;} else break;}}
        //----  BUY      
        if (ld_MA <= ld_Sar) break;
        //----      ,  BUY
        if (li_BAR == fi_BarSignal) {return (BULL);}
    }
    lb_Trend = false;
    //----      (fi_BarSignal)    (fi_VerificationBars) 
    for (li_BAR = fi_BarSignal + fi_VerificationBars; li_BAR >= fi_BarSignal; li_BAR--)
    {
        //----  SAR
        ld_Sar = iSAR (fs_Symbol, fi_TF, SAR_Step, SAR_Maximum, li_BAR);
        //----  
        ld_MA = iMA (fs_Symbol, fi_TF, 3, 0, MODE_SMMA, PRICE_TYPICAL, li_BAR);
        //----    
        if (fb_ControlBeginChangeTrend)
        {if (!lb_Trend) {if (ld_MA >= ld_Sar) {lb_Trend = true; continue;} else break;}}
        //----  SELL      
        if (ld_MA >= ld_Sar) break;
        //----      ,  SELL
        if (li_BAR == fi_BarSignal) {return (BEAR);}
    }
//----
    return (STOP);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          BrakeExp  fi_BarSignal                               |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_SignalBrakeExp (string fs_Symbol,                        // Symbol
                         int fi_TF,                               // 
                         bool fb_ControlBeginChangeTrend = False, //    
                         int fi_BarSignal = 1,                    //     
                         int fi_VerificationBars = 1)             //     
{
    double ld_IND, ld_MA;
    bool   lb_Trend = false;
//----
    if (!fb_ControlBeginChangeTrend) fi_VerificationBars--;
    //----      (fi_BarSignal)    (fi_VerificationBars) 
    for (int li_BAR = fi_BarSignal + fi_VerificationBars; li_BAR >= fi_BarSignal; li_BAR--)
    {
        //----     
        ld_IND = iCustom (fs_Symbol, fi_TF, NAME_Ind, ValueA, ValueB, IsLine, 0, li_BAR);
        //----  ,     
        if (ld_IND == EMPTY_VALUE)
        {ld_IND = iCustom (fs_Symbol, fi_TF, NAME_Ind, ValueA, ValueB, IsLine, 1, li_BAR);}
        //----      , 
        if (ld_IND == EMPTY_VALUE) return (STOP);
        //----  
        ld_MA = iMA (fs_Symbol, fi_TF, 3, 0, MODE_SMMA, PRICE_TYPICAL, li_BAR);
        //----    
        if (fb_ControlBeginChangeTrend)
        {if (!lb_Trend) {if (ld_MA <= ld_IND) {lb_Trend = true; continue;} else break;}}
        //----  BUY      
        if (ld_MA <= ld_IND) break;
        //----      ,  BUY
        if (li_BAR == fi_BarSignal) {return (BULL);}
    }
    //----      (fi_BarSignal)    (fi_VerificationBars) 
    for (li_BAR = fi_BarSignal + fi_VerificationBars; li_BAR >= fi_BarSignal; li_BAR--)
    {
        ld_IND = iCustom (fs_Symbol, fi_TF, NAME_Ind, ValueA, ValueB, IsLine, 0, li_BAR);
        if (ld_IND == EMPTY_VALUE)
        {ld_IND = iCustom (fs_Symbol, fi_TF, NAME_Ind, ValueA, ValueB, IsLine, 1, li_BAR);}
        if (ld_IND == EMPTY_VALUE) return (STOP);
        //----  
        ld_MA = iMA (fs_Symbol, fi_TF, 3, 0, MODE_SMMA, PRICE_TYPICAL, li_BAR);
        //----    
        if (fb_ControlBeginChangeTrend)
        {if (!lb_Trend) {if (ld_MA >= ld_IND) {lb_Trend = true; continue;} else break;}}
        //----  SELL      
        if (ld_MA >= ld_IND) break;
        //----      ,  SELL
        if (li_BAR == fi_BarSignal) {return (BEAR);}
    }
//----
    return (STOP);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fControl_BeginChangeTrend (int fi_ControlBeginChangeTrend = 0,  //  
                                bool fb_FirstOrder = true)           //    ( )
{
//----
    if (fi_ControlBeginChangeTrend == 0) return (false);
    switch (fi_ControlBeginChangeTrend)
    {
        case 1: if (fb_FirstOrder) return (true);
        case 2: if (!fb_FirstOrder) return (true);
        default: return (true);
    }
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
/*void fSet_ValuesIndicators (int fi_VariantSend, int fi_VariantClose)
{
    string ls_SUM = StringConcatenate (fi_VariantSend, fi_VariantClose);
    int    li_SUM = StrToInteger (ls_SUM);
//----
    switch (li_SUM)
    {
        case 0: USE_SAR = 1; USE_BrakeExp = 0; break;
        case 1: USE_SAR = 2; USE_BrakeExp = 0; break;
        case 2: USE_SAR = 1; USE_BrakeExp = 2; break;
        case 10: USE_SAR = 3; USE_BrakeExp = 0; break;
        case 10: USE_SAR = 1; USE_BrakeExp = 0; break;
        case 10: USE_SAR = 1; USE_BrakeExp = 0; break;
        case 10: USE_SAR = 1; USE_BrakeExp = 0; break;
    }
//----
}*/
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

